;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;DIALOG CODEING
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
dialog jamdd {
  title "Dialog Designer"
  size -1 -1 165 58
  option dbu
  icon $dialog.icon , 0
  list 23, 3 2 50 45, extsel size    
  tab "Color", 1, -18 -18 190 97     
  check "Enable Background:", 2, 62 7 61 10, tab 1 left
  check "Enable Edit/List Fields:", 3, 62 40 61 10, tab 1 left
  check "Enable Dialog Text:", 4, 62 24 61 10, tab 1 left
  combo 5, 130 5 30 50, tab 1 size drop
  combo 6, 130 38 30 50, tab 1 size drop
  combo 7, 130 22 30 50, tab 1 size drop
  tab "Style", 8,
  text "Edit Field(s) Style:", 9, 60 9 45 8, tab 8
  combo 10, 111 7 50 50, tab 8 size drop
  text "Font(s) Style:", 11, 60 41 45 8, tab 8
  text "Button(s) Style:", 12, 60 25 45 8, tab 8
  combo 13, 111 23 50 50, tab 8 size drop
  combo 14, 111 39 50 52, tab 8 size drop
  tab "Dock", 15,
  combo 16, 111 6 50 50, tab 15 drop
  text "Dock Contral Bar On:", 17, 57 9 50 8, tab 15
  box "",18, 57 17 104 5, tab 15
  button "Src",19, 57 25 15 8, tab 15
  edit "",20, 57 39 50 8, tab 15 autohs read
  icon "",21, 128 25 32 27, $dialog.icon tab 15
  text "Dialog Icon",22, 74 26 30 8, tab 15
  tab "Program",25, 
  list 24, 55 3 108 30, extsel size tab 25
  button "Add",26, 85 37 15 8, tab 25
  button "Del",27, 101 37 15 8, tab 25
  button "Edit",28, 117 37 15 8, tab 25
  text "Name:",29, 55 49 20 8, tab 25
  edit "",30, 70 48 35 8, autohs tab 25
  button "Src",31, 108 48 15 8, tab 25
  edit "",32, 126 48 37 8, autohs tab 25
  button "?",99, 13 49 15 8
  button "X",100, 29 49 15 8, cancel
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;COLOR ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias dd.d.c.a {
  dll $mdx SetDialog $dname bgcolor $dialog.color
  dll $mdx SetColor 2,3,4,9,11,12,17,19,22,29,30,32 textbg $dialog.color
  dll $mdx SetColor 2,3,4,9,11,12,17,19,22,29,30,32 background $dialog.color
}
alias dd.t.c.a {
  dll $mdx SetColor 2,3,4,9,10,11,12,13,14,16,17,19,20,21,22,29,30,32 text $text.color
  did -i $dname 23 1 setcolor text $text.color
  did -i $dname 23 1 setcolor line $text.color
  did -i $dname 24 1 settxt color $text.color
}
alias dd.el.c.a {
  dll $mdx SetColor 5,6,7,10,13,14,16,20,30,32 background $edit.list.color
  dll $mdx SetColor 5,6,7,10,13,14,16,20,30,32 textbg $edit.list.color
  did -i $dname 23 1 setcolor bkg $edit.list.color
  did -i $dname 24 1 settxt bgcolor $edit.list.color
  did -i $dname 24 1 setbkg color $edit.list.color  
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;INIT EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamdd:init:0:{
  mdx.init
  dll $mdx SetControlMDX $dname 23 TreeView haslines linesatroot hasbuttons editlabels > $scriptdirdlls\views.mdx
  did -a $dname 23 +eb Options
  did -i $dname 23 1 cb root last 1
  did -a $dname 23 +e Color
  did -a $dname 23 +e Style
  did -a $dname 23 +e Program
  did -a $dname 23 +e Other
  dll $mdx SetControlMDX $dname 24 Listview report grid> $scriptdirDLLS\views.mdx
  did -i $dname 24 1 headerdims 70 130
  did -i $dname 24 1 headertext Name $chr(9) .Exe
  dll $mdx SetBorderStyle $dname 20,23,24,30,32 style $hget(system,border.style)
  dll $mdx SetBorderStyle $dname 19,26,27,28,31,99,100 style $gettok($hget(system,button.style),1,32)
  dll $mdx SetFont $dname 2,3,4,9,10,11,12,13,14,16,17,19,20,22,23,24,26,27,28,29,30,31,32 -10 400 $gettok($hget(system,font.style),1,32)
  dll $combo COMBO $dname 5
  dll $combo COMBO $dname 6
  dll $combo COMBO $dname 7
  var %dialog = $hget(system,dialogcolor)
  var %el = $hget(system,editlistcolor)
  var %text = $hget(system,textcolor)
  inc %dialog 2 | inc %el 2 | inc %text 2
  if ( $hget(system,d.c) == on ) { did -c jamdd 2 }
  did -c jamdd 5 %dialog
  if ( $hget(system,e.l.c) == on ) { did -c jamdd 3 }
  did -c jamdd 6 %el
  if ( $hget(system,t.c) == on ) { did -c jamdd 4 }
  did -c jamdd 7 %text
  get.borders.c
  get.styles.c
  get.fonts.c
  get.dock.c
  if ( $hget(system,d.c) == on ) { dd.d.c.a }
  if ( $hget(system,t.c) == on ) { dd.t.c.a }
  if ( $hget(system,e.l.c) == on ) { dd.el.c.a }
  get.pro.list
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias ultradock { return $+(",$scriptdirdlls\UltraDock.dll,") }
alias jamdd { if (!$dialog(jamdd)) { dialog -m jamdd jamdd } | else { dialog -ve jamdd } }
alias get.borders.c {
  var %borders = border dlgframe clientedge dlgmodal staticedge windowedge
  var %b = 1
  while ( $gettok(%borders,%b,32) ) {
    did -a jamdd 10 $ifmatch
    inc %b
  }
  var %b.sel = $gettok($hget(system,border.style),2,32)
  did -c jamdd 10 %b.sel
}
alias get.styles.c {
  var %styles = border dlgframe clientedge dlgmodal staticedge windowedge
  var %c = 1
  while ( $gettok(%styles,%c,32) ) {
    did -a jamdd 13 $ifmatch
    inc %c
  }
  var %s.sel = $gettok($hget(system,button.style),2,32)
  did -c jamdd 13 %s.sel
}
alias get.fonts.c {
  var %fonts = Tahoma Terminal Times-New-Roman 
  var %a = 1
  while ( $gettok(%fonts,%a,32) ) {
    did -a jamdd 14 $ifmatch
    inc %a
  }
  var %f.sel = $gettok($hget(system,font.style),2,32)
  did -c jamdd 14 %f.sel
}
alias get.dock.c {
  var %bar.pos = left right Undock
  var %d = 1
  while ( $gettok(%bar.pos,%d,32) ) {
    did -a jamdd 16 $ifmatch
    inc %d
  }
  var %d.sel = $gettok($hget(system,dock.style),2,32)
  did -c jamdd 16 %d.sel
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ALIASE by tidy_trax
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias background2 {
  if ($0 == 1) { background $1 }
  else {
    if ($chr(3) isin $ [ $+ [ $0 ] ]) { tokenize 32 $1 [ $+ [ - [ $+ [ $calc($0 -1) ] ] ] ] $colour($remove($ [ $+ [ $0 ] ],$chr(3))) }
    close -@ @bg
    window -hp @bg
    drawrect -fr @bg $ [ $+ [ $0 ] ] 1 0 0 $window(@bg).w $window(@bg).h
    drawsave @bg " $+ $scriptdirbg.jpg"
    close -@ @bg
    background $1 [ $+ [ - [ $+ [ $calc($0 -1) ] ] ] ] " $+ $scriptdirbg.jpg"
    if (-*q* !iswm $1) { .remove " $+ $scriptdirbg.jpg" }
  }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;COLOR ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias v.dialog.color {   
  var %sel = $did($dname,$did).sel
  dec %sel 2
  hadd system dialogcolor %sel
  system.update
}
alias e.l.color {
  var %sel = $did($dname,$did).sel
  dec %sel 2
  hadd system editlistcolor %sel
  system.update
}
alias v.text.color {
  var %sel = $did($dname,$did).sel
  dec %sel 2
  hadd system textcolor %sel
  system.update
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;PROGRAM ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias pro.hash.make {  
  hmake program
  hload -i program $+(",$scriptdirhashtables\program.hsh,")
}
alias pro.hash.update { 
  hsave -io program $+(",$scriptdirhashtables\program.hsh,") 
}
alias add.pro {
  var %name = $did(jamdd,30).text
  var %source = $did(jamdd,32).text
  hadd program %name %source
  did -r jamdd 30
  did -r jamdd 32
  pro.hash.update
  get.pro.list
}
alias del.pro {
  var %name = $gettok($did(jamdd,24).seltext,6-,32)
  var %rem = $gettok(%name,1,32)
  var %i = 1
  while ( $hget(program,%i).item ) {
    if ( $v1 == %rem ) { hdel program %rem | pro.hash.update }
    inc %i
  }
  get.pro.list
}
alias edit.pro {
  var %name = $gettok($did(jamdd,24).seltext,6-,32)
  var %rem = $gettok(%name,1,32)
  did -ra jamdd 30 %rem
  did -ra jamdd 32 $hget(program,%rem)
}
alias get.pro.list {
  did -r jamdd 24
  var %i = 1
  while ( $hget(program,%i).item ) {
    did -a jamdd 24 $v1 $chr(9) $nopath($hget(program,%i).data) 
    inc %i
  }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;HELP ALIAS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias get.dd.help {
  var %dd.path = $remove($+(",$scriptdirHelp\Dialog Design\dialog.htm,"),$chr(34))
  window -ak(0) @Help 
  echo @Help $dll($nHTMLn,attach,$window(@Help).hwnd) 
  echo @Help $dll($nHTMLn,navigate,%dd.path) 
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;SCLICK EVENTS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamdd:sclick:*:{
  if ( $did == 2 ) { if ( $did(2).state == 1 ) { hadd system d.c on | system.update } | elseif ( $did(2).state == 0 ) { hadd system d.c off | system.update } }
  if ( $did == 3 ) { if ( $did(3).state == 1 ) { hadd system e.l.c on | system.update } | elseif ( $did(3).state == 0 ) { hadd system e.l.c off | system.update } } 
  if ( $did == 4 ) { if ( $did(4).state == 1 ) { hadd system t.c on | system.update } | elseif ( $did(4).state == 0 ) { hadd system t.c off | system.update } } 
  if ( $did == 5 ) { v.dialog.color }
  if ( $did == 6 ) { e.l.color }
  if ( $did == 7 ) { v.text.color }
  if ( $did == 10 ) { hadd system border.style $did(10).text $did(10).sel | system.update }
  if ( $did == 13 ) { hadd system button.style $did(13).text $did(13).sel | system.update }
  if ( $did == 14 ) { var %z = $replace($did(14).text,$chr(45),$chr(32)) | hadd system font.style %z $did(14).sel | system.update }
  if ( $did == 16 ) { hadd system dock.style $did(16).text $did(16).sel | system.update }
  if ( $did == 19 ) { var %i.source = $sdir="Enter Source Dir" | var %icon = $sfile(%i.source) | hadd system dialog.icon %icon | system.update | did -ra jamdd 20 $nopath(%icon) }
  if ( $did == 23 ) {
    var %i = $branch(jamdd,23)
    if ( %i == Color ) { did -f jamdd 1 }
    elseif ( %i == Style ) { did -f jamdd 8 }
    elseif ( %i == Other ) { did -f jamdd 15 }
    elseif ( %i == Program ) { did -f jamdd 25 }
  }
  if ( $did == 26 ) { add.pro }
  if ( $did == 27 ) { del.pro }
  if ( $did == 28 ) { edit.pro }
  if ( $did == 31 ) { var %sou = $sfile($mircdir) | did -ra jamdd 32 %sou }
  if ( $did == 99 ) { get.dd.help } 
  if ( $did == 100 ) { 
    if ( $gettok($hget(system,dock.style),1,32) == left ) { 
      if (!$dialog(jatb)) {
        system.update 
        jatb 
        if ( $hget(system,d.c) == on ) { 
          background2 -qel $dialog.color 
          background2 -qeh $dialog.color 
        }
      }
      else { 
        system.update 
        dialog -c jatb 
        jatb 
        if ( $hget(system,d.c) == on ) { 
          background2 -qel $dialog.color
          background2 -qeh $dialog.color  
        }
      }
    } 
    elseif ( $gettok($hget(system,dock.style),1,32) == right ) { 
      if (!$dialog(jatb)) {
        system.update 
        jatb 
        if ( $hget(system,d.c) == on ) { 
          background2 -qel $dialog.color
          background2 -qeh $dialog.color  
        }
      }
      else { 
        system.update 
        dialog -c jatb 
        jatb 
        if ( $hget(system,d.c) == on ) { 
          background2 -qel $dialog.color 
          background2 -qeh $dialog.color 
        }
      }
    }
    elseif ( $gettok($hget(system,dock.style),1,32) == Undock ) { 
      system.update 
      dll $ultradock UnDock 0 
      dialog -c jatb 
      .timerlagmeter off 
      if ( $hget(system,d.c) == on ) { 
        background2 -qel $dialog.color
        background2 -qeh $dialog.color  
      }
    }
  }
}
