;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;DIALOG EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
dialog jamaj {
  title "Auto Joiner"
  size -1 -1 264 66
  option dbu
  icon $dialog.icon , 0  
  tab "Joiner", 1, -16 -16 290 105  
  list 2, 56 3 205 30, size tab 1 
  text "Timer Gap Of ", 3, 58 41 33 8, tab 1  
  edit "", 4, 91 39 10 8, center tab 1
  text "Secs Between Each Join", 5, 103 41 62 8, tab 1
  button "Add", 6, 197 39 15 8, tab 1
  button "Del", 7, 213 39 15 8, tab 1
  button "Edit", 8, 229 39 15 8, tab 1
  text "Network:", 9, 57 56 25 8, tab 1
  edit "", 10, 79 54 58 8, autohs tab 1
  text "Channels:", 11, 141 56 25 8, tab 1
  edit "", 12, 164 54 96 8, autohs tab 1
  tab "Password",13,
  list 14, 58 4 106 58, size tab 13
  button "Add", 15, 192 52 15 8, tab 13
  button "Del", 16, 208 52 15 8, tab 13
  button "Edit", 17, 224 52 15 8, tab 13
  text "Channel:", 18, 176 7 24 8, tab 13
  edit "", 19, 175 14 78 8, autohs center tab 13
  text "Password:", 20, 176 31 24 8, tab 13
  edit "", 21, 175 38 78 8, autohs center tab 13
  button "?", 22, 13 56 15 8
  button "X", 23, 28 56 15 8, cancel
  list 24, 3 3 50 50, extsel size

}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;COLOR ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias aj.d.c.a {
  dll $mdx SetDialog $dname bgcolor $dialog.color
  dll $mdx SetColor 2,3,4,5,9,10,11,12,14,18,19,20,21 textbg $dialog.color
  dll $mdx SetColor 2,3,4,5,9,10,11,12,14,18,19,20,21 background $dialog.color
}
alias aj.t.c.a {
  dll $mdx SetColor 2,3,4,5,9,10,11,12,18,19,20,21 text $text.color
  did -i $dname 2 1 settxt color $text.color
  did -i $dname 14 1 settxt color $text.color
  did -i $dname 24 1 setcolor text $text.color
  did -i $dname 24 1 setcolor line $text.color
}
alias aj.el.c.a {         
  dll $mdx SetColor 2,4,10,12,19,21 background $edit.list.color
  dll $mdx SetColor 2,4,10,12,19,21 textbg $edit.list.color
  did -i $dname 2 1 settxt bgcolor $edit.list.color
  did -i $dname 2 1 setbkg color $edit.list.color
  did -i $dname 14 1 settxt bgcolor $edit.list.color
  did -i $dname 14 1 setbkg color $edit.list.color  
  did -i $dname 24 1 setcolor bkg $edit.list.color
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias jamaj { if (!$dialog(jamaj)) { dialog -m jamaj jamaj } | else { dialog -ve jamaj } }
alias add.aj {
  var %net = $did(10).text
  var %chan = $did(12).text
  hadd system %net %chan ajoin
  get.ajs
  did -r jamaj 10
  did -r jamaj 12
}
alias del.aj {
  var %info = $did(jamaj,2).seltext
  var %net = $gettok(%info,6,32)
  hdel system %net
  get.ajs
}
alias edit.aj {
  var %info = $did(jamaj,2).seltext
  var %net = $gettok(%info,6,32)
  var %chans = $gettok(%info,11-,32)
  did -a jamaj 10 %net
  did -a jamaj 12 %chans
}
alias get.ajs {
  did -r jamaj 2
  var %i = 1
  while ( $hget(system,%i).item ) {
    var %net = $ifmatch , %chans = $hget(system,%i).data, 
    if ( $right(%chans,5) == ajoin ) { 
    did -a $dname 2 %net $chr(9) $remove(%chans,ajoin) }
    inc %i
  }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;CHANNEL ADD/EDIT/DELETE ALIASES 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias add.chan.a {
  var %chan = $did(19).text
  var %pass = $did(21).text
  hadd system %chan %pass
  system.update
  did -r jamaj 19
  did -r jamaj 21
  get.chan.pass
}
alias del.chan.a {
  var %chan = $gettok($did(14).seltext,6,32)
  hdel system %chan
  system.update
  get.chan.pass
}
alias edit.chan.a {
  var %chan = $gettok($did(14).seltext,6,32)
  var %pass = $gettok($did(14).seltext,11,32)
  hdel system %chan
  did -ra jamaj 19 %chan 
  did -ra jamaj 21 %pass
}
alias get.chan.pass {
  did -r jamaj 14
  var %i = 1
  while ( $hget(system,%i).item ) {
    var %info = $ifmatch
    if ( $left(%info,1) == $chr(35) ) { 
      var %pass = $hget(system,%i).data 
      did -a jamaj 14 %info $chr(9) %pass
    }
    inc %i
  }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;INIT EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamaj:init:0:{
  mdx.init
  dll $mdx SetControlMDX $dname 2 ListView report single sortascending > $scriptdirdlls\views.mdx
  did -i $dname 2 1 headerdims 90 306
  did -i $dname 2 1 headertext Network $chr(9) Channels
  get.ajs
  did -a jamaj 4 $hget(system,ajoin.gap)
  dll $mdx SetControlMDX $dname 14 ListView report single sortascending > $scriptdirdlls\views.mdx
  did -i $dname 14 1 headerdims 103 103
  did -i $dname 14 1 headertext Channel $chr(9) Password
  get.chan.pass
  dll $mdx SetControlMDX $dname 24 TreeView haslines linesatroot hasbuttons > $scriptdirdlls\views.mdx
  did -a $dname 24 +eb Options
  did -i $dname 24 1 cb root last 1
  did -a $dname 24 +e Joiner
  did -a $dname 24 +e Password
  dll $mdx SetBorderStyle $dname 6,7,8,15,16,17,22,23 style $hget(system,button.style)
  dll $mdx SetBorderStyle $dname 2,4,10,12,14,19,21,24 style $hget(system,border.style)
  dll $mdx SetFont $dname 2,3,4,5,6,7,8,9,10,11,12,14,15,16,17,18,19,20,23,22,23,24 -10 400 $gettok($hget(system,font.style),1,32)
  if ( $hget(system,d.c) == on ) { aj.d.c.a }
  if ( $hget(system,t.c) == on ) { aj.t.c.a }
  if ( $hget(system,e.l.c) == on ) { aj.el.c.a }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;HELP ALIAS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias get.aj.help {
  var %aj.path = $remove($+(",$scriptdirHelp\Auto Joiner\autojoiner.htm,"),$chr(34))
  window -ak(0) @Help 
  echo @Help $dll($nHTMLn,attach,$window(@Help).hwnd) 
  echo @Help $dll($nHTMLn,navigate,%aj.path) 
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;SCLICK EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamaj:sclick:*:{
  if ( $did == 6 ) { add.aj }
  if ( $did == 7 ) { del.aj }
  if ( $did == 8 ) { edit.aj }
  if ( $did == 15 ) { add.chan.a }
  if ( $did == 16 ) { del.chan.a }
  if ( $did == 17 ) { edit.chan.a }
  if ( $did == 22 ) { get.aj.help } 
  if ( $did == 23 ) { window -c @help | system.update }
  if ( $did == 24 ) {
    var %i = $branch(jamaj,24)
    if ( %i == Joiner ) { did -f jamaj 1 }
    elseif ( %i == Password ) { did -f jamaj 13 }
  }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;EDIT EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamaj:edit:4:{ hadd system ajoin.gap $did(4).text | system.update }
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;MAIN JOIN ALIAS AND CONNECT EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:CONNECT:{
  set -u10 %network $network
  var %i = 1
  while ( $hget(system,%i).item ) {
    set -u10 %net $ifmatch 
    set -u10 %chans $hget(system,%i).data
    if ( %network == %net ) && ( $right(%chans,5) == ajoin ) { joins.go }
    inc %i
  }
}
alias joins.go {
  if ( %network == %net ) {
    var %x = 1
    while ( $gettok(%chans,%x,32) ) {
      var %to.join = $ifmatch
      if ( %to.join == ajoin ) { halt }
      var %pass = $hget(system,%to.join)
      .timer $+ %to.join $+ %i 1 $hget(system,ajoin.gap) join %to.join %pass
      inc %x
    }
  }
  .timer 1 2 unset %network
  .timer 1 2 unset %net
  .timer 1 2 unset %chans
}
