;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;DIALOG CODEING
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
dialog jamfk {
  title "Fkeys/Alias Viewer"
  size -1 -1 88 94
  option dbu
  icon $dialog.icon , 0
  list 1, 3 2 82 50, size
  combo 2, 3 69 20 50, size drop
  button "Add", 3, 28 57 15 8
  button "Edit", 4, 44 57 15 8
  text "Assign:", 5, 27 73 19 8
  edit "", 6, 44 71 41 8
  button "?", 7, 28 84 15 8
  button "X", 8, 44 84 15 8, cancel
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;COLOR ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias fk.d.c.a {
  dll $mdx SetDialog $dname bgcolor $dialog.color
  dll $mdx SetColor 5 textbg $dialog.color
  dll $mdx SetColor 5 background $dialog.color
}
alias fk.t.c.a {
  dll $mdx SetColor 2,5,6 text $text.color
  did -i $dname 1 1 settxt color $text.color
}
alias fk.el.c.a {         
  dll $mdx SetColor 2,6 background $edit.list.color
  dll $mdx SetColor 2,6 textbg $edit.list.color
  did -i $dname 1 1 settxt bgcolor $edit.list.color
  did -i $dname 1 1 setbkg color $edit.list.color 
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias jamfk { if (!$dialog(jamfk)) { dialog -m jamfk jamfk } | else { dialog -ve jamfk } }
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;FKEYS ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias f2 var %type = f2 | var %command = $hget(system,%type) | %command
alias f3 var %type = f3 | var %command = $hget(system,%type) | %command
alias f4 var %type = f4 | var %command = $hget(system,%type) | %command
alias f5 var %type = f5 | var %command = $hget(system,%type) | %command
alias f6 var %type = f6 | var %command = $hget(system,%type) | %command
alias f7 var %type = f7 | var %command = $hget(system,%type) | %command
alias f8 var %type = f8 | var %command = $hget(system,%type) | %command
alias f9 var %type = f9 | var %command = $hget(system,%type) | %command
alias f10 var %type = f10 | var %command = $hget(system,%type) | %command
alias f11 var %type = f11 | var %command = $hget(system,%type) | %command
alias f12 var %type = f12 | var %command = $hget(system,%type) | %command
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;HELP ALIAS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias get.fkey.help {
  var %fkey.path = $remove($+(",$scriptdirHelp\fkeys\fkeys.htm,"),$chr(34))
  window -ak(0) @Help 
  echo @Help $dll($nHTMLn,attach,$window(@Help).hwnd) 
  echo @Help $dll($nHTMLn,navigate,%fkey.path) 
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;KEYS ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias update.key {
  var %z = $did(2).text
  var %p = $did(6).text
  hadd system %z %p
  system.update
  get.keys
  did -r jamfk 6
}
alias edit.key {
  var %i = $did(jamfk,1).seltext
  var %key = $gettok(%i,6,32)
  var %command = $gettok(%i,11,32)
  var %sel = $right(%key,1)
  dec %sel
  did -c jamfk 2 %sel
  did -ra jamfk 6 %command
}
alias get.keys {
  did -r jamfk 1
  did -a jamfk 1 /daway $chr(9) go away
  did -a jamfk 1 /dback $chr(9) go back
  did -a jamfk 1 /stats.go $chr(9) spam stats
  did -a jamfk 1 f1 $chr(9) mIRC help
  did -a jamfk 1 f2 $chr(9) $hget(system,f2)
  did -a jamfk 1 f3 $chr(9) $hget(system,f3)
  did -a jamfk 1 f4 $chr(9) $hget(system,f4)
  did -a jamfk 1 f5 $chr(9) $hget(system,f5)
  did -a jamfk 1 f6 $chr(9) $hget(system,f6)
  did -a jamfk 1 f7 $chr(9) $hget(system,f7)
  did -a jamfk 1 f8 $chr(9) $hget(system,f8)
  did -a jamfk 1 f9 $chr(9) $hget(system,f9)
  did -a jamfk 1 f10 $chr(9) $hget(system,f10)
  did -a jamfk 1 f11 $chr(9) $hget(system,f11)
  did -a jamfk 1 f12 $chr(9) $hget(system,f12)
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;INIT EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamfk:init:0:{
  mdx.init
  dll $mdx SetBorderStyle $dname 3,4,7,8 style $hget(system,button.style)
  dll $mdx SetBorderStyle $dname 1,6 style $hget(system,border.style)
  dll $mdx SetFont $dname 1,2,3,4,5,6,7,8 -10 400 $gettok($hget(system,font.style),1,32)
  dll $mdx SetControlMDX $dname 1 ListView report single grid > $scriptdirdlls\views.mdx
  did -i $dname 1 1 headerdims 60 82
  did -i $dname 1 1 headertext "" $chr(9) Command
  did -a jamfk 1 /daway $chr(9) go away
  did -a jamfk 1 /dback $chr(9) go back
  did -a jamfk 1 /stats.go $chr(9) spam stats
  did -a jamfk 1 f1 $chr(9) mIRC help
  var %info = f2 f3 f4 f5 f6 f7 f8 f9 f10 f11 f12 
  var %x = 1
  while ( $gettok(%info,%x,32) ) {
    var %z = $ifmatch 
    did -a jamfk 2 %z
    inc %x
  }
  get.keys
  if ( $hget(system,d.c) == on ) { fk.d.c.a }
  if ( $hget(system,t.c) == on ) { fk.t.c.a }
  if ( $hget(system,e.l.c) == on ) { fk.el.c.a }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;SCLICK EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamfk:sclick:*:{
  if ( $did == 3 ) { update.key }
  if ( $did == 4 ) { edit.key }
  if ( $did == 7 ) { get.fkey.help } 
  if ( $did == 8 ) { window -c @help | system.update }
}
